Option Explicit

#include ..\lib\framework_domotics.vbs
#include local-parameters.inc


Sub main
Dim atabDv
Dim astrNbDv
Dim astrConfig
Dim astrDevices
Dim astrDevice
Dim i
Dim j
Dim astrPARAM1
Dim astrPARAM2
Dim adapter
Dim access
Dim owd_enum
Dim owd
Dim deviceFound
Dim OneWireAddress
Dim state
Dim aNbTemp
Dim astrKeys
Dim atabKeys
Dim astrValues
Dim atabValues
Dim aDblTemp
Dim astrOneWireReader
Dim astrDigitemp
Dim astrDigitempOutput
Dim astrBuffer
Dim atabRows
Dim atabCols
Dim astrSensor

WriteLog G_FOLDER_NAME, G_SCRIPT_EVT, G_TIV_INF, "Launching " & G_FOLDER_NAME & " script", G_LOG_FILE

If CheckDevices(G_FOLDER_NAME, G_FILE_INI, G_STATUS_EXIST) Then
	astrDevices 		= hs.GetINISetting("COMMON","DEVICES","", G_FILE_INI)
	astrConfig  		= hs.GetINISetting("COMMON","CONFIG","..\scripts\config\", G_FILE_INI)
	astrOneWireReader	= hs.GetINISetting("COMMON","ONE_WIRE_READER","", G_FILE_INI)
	astrDigitemp		= hs.GetINISetting("COMMON","DIGITEMP_BAT","", G_FILE_INI)
	astrDigitempOutput	= hs.GetINISetting("COMMON","DIGITEMP_OUTPUT","", G_FILE_INI)
	atabDv	 			= Split(astrDevices, G_SEP)
	astrNbDv 			= UBound(atabDv) 
	
	If astrOneWireReader <> "DIGITEMP" Then
		WriteLog G_FOLDER_NAME, G_SCRIPT_EVT, G_TIV_INF, "Using owapi.OneWireAccessProvider as Reader", G_LOG_FILE
		aNbTemp=0
		astrKeys = ""
		Set access = CreateObject("owapi.OneWireAccessProvider")
		Set adapter = access.getDefaultAdapter
		adapter.beginExclusive(true)
		adapter.setSearchAllDevices
		adapter.targetAllFamilies
		adapter.setSpeed(adapter.SPEED_REGULAR)
		Set owd_enum = adapter.getAllDeviceContainers
		deviceFound = 0
		While owd_enum.hasMoreElements
			Set owd = owd_enum.nextElement
			Set owd = owd.getMostSpecificComponent
			If owd.IsTemperatureContainer Then
				deviceFound = 1
				OneWireAddress = owd.getAddressAsString
				If astrKeys = "" Then
					astrKeys = OneWireAddress
				Else
					astrKeys = astrKeys & G_SEP & OneWireAddress
				End if
				Set state = owd.readDevice
				owd.doTemperatureConvert(state)
				Set state = owd.readDevice
				If astrValues = "" Then
					astrValues = Cstr(Round(owd.getTemperature(state), 2))
				Else
					astrValues = astrValues & G_SEP & Cstr(Round(owd.getTemperature(state), 2))
				End if
				aNbTemp = aNbTemp + 1	
			End If
		WEnd
		adapter.endExclusive()
		adapter.freePort()
		adapter.freeObject()
		'Set state = Nothing
		'Set owd = Nothing
		'Set owd_enum = Nothing
		'Set adapter = Nothing
		Set access = Nothing	
		
		If (deviceFound = 0) Then 
			WriteLog G_FOLDER_NAME, G_SCRIPT_EVT, G_TIV_SEV, "No 1-Wire Thermometers found!", G_LOG_FILE
			
		Else
			i=0	
			atabKeys = Split(astrKeys, G_SEP)
			atabValues = Split(astrValues, G_SEP)
			If Ubound(atabKeys) = aNbTemp -1 Then
				While (i <= Cint(astrNbDv))	
					astrPARAM1 = hs.GetINISetting("DEVICE", "PARAM1", "???", astrConfig & atabDv(i))
					astrPARAM2 = hs.GetINISetting("DEVICE", "PARAM2", "0", astrConfig & atabDv(i))
					astrDevice = hs.GetINISetting("DEVICE", "HC", "", astrConfig & atabDv(i)) & _ 
								 hs.GetINISetting("DEVICE", "DC", "", astrConfig & atabDv(i))

					j=0
					While (j < aNbTemp)	
						If astrPARAM1 = atabKeys(j) Then
							aDblTemp = CDbl(atabValues(j)) + CDbl(astrPARAM2) 'CDbl(atabValue(1)) + CDbl(astrPARAM2)
							WriteLog G_FOLDER_NAME, G_SCRIPT_EVT, G_TIV_INF, aDblTemp & " is found", G_LOG_FILE
							SetDevice astrDevice, aDblTemp, "", ""
						End if
					j = j +1
					Wend
					i=i+1
				Wend
			Else
				WriteLog G_FOLDER_NAME, G_SCRIPT_EVT, G_TIV_SEV, "Error reading 1-Wire network!", G_LOG_FILE
			End if
		End if
		
	Else		'-- using Digitemp !
		WriteLog G_FOLDER_NAME, G_SCRIPT_EVT, G_TIV_INF, "Using digitemp as Reader", G_LOG_FILE
		If (astrDigitemp <> "") Then
			If isFileExist(astrDigitemp) Then
				executeShellAndWait(astrDigitemp)
				astrBuffer = ""
				astrBuffer = loadfile(astrDigitempOutput,True)
				If (astrBuffer <> "") Then '28 Jan 15 33 19 Sensor 5 13.63
					astrBuffer 		= replace(astrBuffer,chr(13),"|")
					atabRows		= Split(astrBuffer,"|")
					i=0
					If Ubound(atabRows) = Cint(astrNbDv)+1 Then
						While (i < Ubound(atabRows))
							atabCols = Split(atabRows(i)," ")
							If Ubound(atabCols) = 7 Then 
								WriteLog G_FOLDER_NAME, G_SCRIPT_EVT, G_TIV_INF, "Checking day consistency" , G_LOG_FILE
								If (CInt(Day(Now)) = CInt(atabCols(0))) or (Cint(Day(Now))-1 = CInt(atabCols(0))) Then
									WriteLog G_FOLDER_NAME, G_SCRIPT_EVT, G_TIV_INF, "Checking hour consistency" , G_LOG_FILE
									If (Cint(Hour(Now)) = CInt(atabCols(2))) or (Cint(Hour(Now))-1 = CInt(atabCols(2))) Then
										WriteLog G_FOLDER_NAME, G_SCRIPT_EVT, G_TIV_INF, "Searching devices" , G_LOG_FILE
										j = 0
										While (j<=Cint(astrNbDv))
											astrDevice 	= hs.GetINISetting("DEVICE", "HC", "", astrConfig & atabDv(j)) & _ 
									       				  hs.GetINISetting("DEVICE", "DC", "", astrConfig & atabDv(j))
									       	astrPARAM2  = hs.GetINISetting("DEVICE", "PARAM2", "0", astrConfig & atabDv(j))
											astrSensor	= hs.GetINISetting("DEVICE","PARAM3","",astrConfig & atabDv(j))
											If atabCols(6) = astrSensor Then
												aDblTemp = CDbl(replace(atabCols(7),".",","))
												aDblTemp = CDbl(aDblTemp + CDbl(astrPARAM2))
												SetDevice astrDevice, Cstr(aDblTemp), "", Cint(aDblTemp*100)
												j = Cint(astrNbDv)
											End if
											j = j + 1
										Wend
									Else
										WriteLog G_FOLDER_NAME, G_SCRIPT_EVT, G_TIV_CRI, "Digitemp output is too old (" & Hour(Now) & "," & atabCols(2) & ")", G_LOG_FILE
									End if
								Else
									WriteLog G_FOLDER_NAME, G_SCRIPT_EVT, G_TIV_CRI, "Digitemp output is too old (" & Day(Now) & "," & atabCols(0) & ")", G_LOG_FILE
								End if
							Else
								WriteLog G_FOLDER_NAME, G_SCRIPT_EVT, G_TIV_CRI, "Digitemp output is strange (" & Ubound(atabCols) & ")", G_LOG_FILE
							End if
							i = i + 1
						Wend
					Else
						WriteLog G_FOLDER_NAME, G_SCRIPT_EVT, G_TIV_CRI, "Not enough digitemp devices (" & Ubound(atabRows) & "," & cint(astrNbDv)+1 & ")", G_LOG_FILE
					End if
				Else
					WriteLog G_FOLDER_NAME, G_SCRIPT_EVT, G_TIV_INF, "Digitemp.cfg not found. Please run digitemp -i manually before", G_LOG_FILE
				End if
			Else
				WriteLog G_FOLDER_NAME, G_SCRIPT_EVT, G_TIV_INF, "Digitemp.exe not found", G_LOG_FILE
			End if
		Else
			WriteLog G_FOLDER_NAME, G_SCRIPT_EVT, G_TIV_INF, "Digitemp Folder and Exe not set !", G_LOG_FILE
			
		End if
	End if

Else
	WriteLog G_FOLDER_NAME, G_SCRIPT_EVT, G_TIV_SEV, "Expected Device is unknown !", G_LOG_FILE
	
End if

WriteLog G_FOLDER_NAME, G_SCRIPT_EVT, G_TIV_INF, "End of the script", G_LOG_FILE
End sub