Sub Main()
Dim access
Dim adapter
Dim showStr
Dim owd
Dim OneWireAddress
Dim CRLF
Dim state
Dim deviceFound
Dim temp(3)

hs.writelog "Debug: " , "starting..."
' make control line feed string
CRLF = Chr(13) & Chr(10)

' get the 1-Wire access provider
Set access = CreateObject("owapi.OneWireAccessProvider")
hs.writelog "Debug: " , "object created..."
' get the default adapter
Set adapter = access.getDefaultAdapter
' print that we got an adapter
hs.writelog "Adapter: " , adapter.getAdapterName & " Port: " & adapter.getPortName

' get exclusive use of 1-Wire network
adapter.beginExclusive(true)

' clear any previous search restrictions
adapter.setSearchAllDevices
adapter.targetAllFamilies
adapter.setSpeed(adapter.SPEED_REGULAR)

' enumerate through all the 1-Wire devices found (with Java-style enumeration)
Set owd_enum = adapter.getAllDeviceContainers
showStr = "1-Wire Thermometer List:" & CRLF
deviceFound = 0
While owd_enum.hasMoreElements
' retrieve OneWireContainer
Set owd = owd_enum.nextElement
' make OneWireContainer into specific OneWireContainer (i.e., OneWireContainer2
Set owd = owd.getMostSpecificComponent
' check to see if 1-Wire device supports temperatures, if so get address and temp.
If owd.IsTemperatureContainer Then
deviceFound = 1
OneWireAddress = owd.getAddressAsString

Select Case OneWireAddress 
case "B00008003BA41910" i=0
case "9700000066ED1C28" i=1
case "B800000066E07C28" i=2
case "CF00000066EAD528" i=3
end select

' read status
Set state = owd.readDevice 
' read the temp
owd.doTemperatureConvert(state)
Set state = owd.readDevice
showStr = showStr & CRLF & "Address = " & OneWireAddress & " Temp: " & (owd.getTemperature(state)) & " C"
temp(i) = Round(owd.getTemperature(state), 2) 
End If
WEnd

' show temperature list
If (deviceFound = 0) Then showStr = showStr & CRLF & "No 1-Wire Thermometers found!"
hs.writelog "", showStr

' end exclusive use of adapter
adapter.endExclusive()

' free port used by adapter
adapter.freePort()

hs.SetDeviceString "m1", temp(0) &"C" 
hs.SetDeviceLastChange "m1",now 
hs.SetDeviceString "m2", temp(1) &"C" 
hs.SetDeviceLastChange "m2",now 
hs.SetDeviceString "m3", temp(2) &"C" 
hs.SetDeviceLastChange "m3",now  
hs.SetDeviceString "m4", temp(3) &"C" 
hs.SetDeviceLastChange "m4",now 

Set adapter = Nothing
Set access = Nothing
End sub