'-----------------------------------------------------------------------
'-------------------------  DOMOTICS LIBRARY ---------------------------
'-- OBJECTIVES : Many functions to simplify your Homeseer scripting
'-- LICENSE    : FREE OF CHARGE FOR NON-COMMERCIAL USE
'-----------------------------------------------------------------------

'--------------------------------------------------------------------
'-- OBJECTIVE   : FUNCTION >> Get Webpage from cache or from web 
'--					according the expected validity
'-- PREREQUISITE: N/A
'-- PARAMS IN   : Url 		(for example http://.../...htm)
'--				  File		(file to store the download,
'--										 or to retrieve cache)
'--				  Strip		(Download page with Html or without Html tags)
'--				  Validity 	(Date to fix a validity)
'-- PARAMS OUT  : The downloaded page with or without Html tags
'-- CREATED BY DOMOTICS
'-- 15/05/2005
'--------------------------------------------------------------------

Function GetAndCacheWebPage(astrURL, astrFile, aboolStrip, adateValidity)
Dim astrWebPage
Dim aboolDownloadAgain
Dim adateLastGet

aboolDownloadAgain = False

If (hs.GetVar(astrURL) = "") Then
	aboolDownloadAgain = True
Else
	adateLastGet = hs.GetVar(astrURL)
	If isDate(adateLastGet) Then
		If DateDiff("N",adateLastGet, Now()) < adateValidity Then
			aboolDownloadAgain = False
			LoadFile astrFile, False
		Else 
			aboolDownloadAgain = True
		End if
	Else 
		aboolDownloadAgain = True
	End if

End If

If aboolDownloadAgain Then
	WriteLog G_DEFAULT_FOLDER_NAME, G_DEFAULT_SCRIPT, G_TIV_INF, "Downloading a new " & astrURL, G_DEFAULT_LOG_FILE
	astrWebPage = hs.GetURLIE(astrURL, aboolStrip)
	If aboolStrip Then
		astrWebPage = CleanString(astrWebPage)
	End if
	SaveFile astrFile, astrWebPage
	SetVar astrURL, Cstr(Now())
Else
	WriteLog G_DEFAULT_FOLDER_NAME, G_DEFAULT_SCRIPT, G_TIV_INF, "Using " & astrURL & " from cache", G_DEFAULT_LOG_FILE
End if

GetAndCacheWebPage = astrWebPage	
End Function

'--------------------------------------------------------------------
'-- OBJECTIVE   : FUNCTION >> Test the network, to know if a given
'--					computer is on-line
'-- PREREQUISITE: N/A
'-- PARAMS IN   : IP		(for example 192.168.1.101)
'--				  cache     (file used to save the information)
'-- PARAMS OUT  : "Available" or "Not available"
'-- CREATED BY DOMOTICS
'-- 15/05/2005
'--------------------------------------------------------------------

function doPing(aparamIPAddress)

If hs.ping(Cstr(aparamIPAddress)) = 0 Then
	doPing = "Available"
Else
	doPing = "Not Available"
End if
End function

'--------------------------------------------------------------------
'-- OBJECTIVE   : PROCEDURE >> Wakeup a PC via LAN 
'-- PREREQUISITE: Require to install WolCom.Wol ( a dll )
'-- PARAMS IN   : MACAddress	(for example 00-0f-ee-78-a4-7d)
'--			 	  IPAddess	(for example 192.168.1.103)
'--				  NetMask	(for example 255.255.255.0)
'-				  Port		(For example 8900)
'-- PARAMS OUT  : N/A
'-- CREATED BY DOMOTICS
'-- 23/07/2005
'--------------------------------------------------------------------

Sub doWakeUp(aparamMAC, aparamIP, aparamNETMASK, aparamPORT)
Set WakeOnLan = CreateObject("WolCom.Wol")
WakeOnLan.TheMacAddress(aparamMAC)
WakeOnLan.TheIpNumber(aparamIP)
WakeOnLan.TheSubnetMask(aparamNETMASK)
WakeOnLan.ThePortNumber(aparamPORT)
WakeOnLan.WakeMeUp
Set WakeOnLan=Nothing
End Sub

'--------------------------------------------------------------------
'-- OBJECTIVE   : PROCEDURE >> send message to NABAZTAG
'-- PREREQUISITE: Nabaztag + a subscription to czerwon.be
'-- PARAMS IN   : Message as a String
'-- PARAMS OUT  : N/A
'-- CREATED BY DOMOTICS
'-- 15/07/2006
'--------------------------------------------------------------------
Sub notifyWithNabaztag(aparamMessage, aparamPOSLEFT, aparamPOSRIGHT, aparamVOICE, aparamFROM, aparamTO)
Dim astrHTTP
Dim astrPage

'-- http://www.czerwon.be/nabaztag/sendTTS.php?voice=claire22s 100 100 Claire&language=fr&from=_domotics&to=domotics&tts=Test !&posleft=5&posright=5&action=sendTTS
If aparamMessage = "" Then
    aparamMessage = G_NABAZTAG_DEFAULT_MESSAGE
End If
If aparamPOSLEFT = "" Then
    aparamPOSLEFT = G_NABAZTAG_POSLEFT
End If
If aparamPOSRIGHT = "" Then
    aparamPOSRIGHT = G_NABAZTAG_POSRIGHT
End If
If aparamVOICE = "" Then
    aparamVOICE = G_NABAZTAG_VOICE
End If 
If aparamFROM = "" Then
    aparamFROM = G_NABAZTAG_FROM
End If 
If aparamTO = "" Then
    aparamTO = G_NABAZTAG_TO
End If 

astrHTTP = "http://www.czerwon.be/nabaztag/sendTTS.php?voice=" & aparamVOICE & "&language=fr&from=" & aparamFROM & "&to=" & aparamTO & "&tts=" & aparamMessage & "&posleft=" & aparamPOSLEFT & "&posright=" & aparamPOSRIGHT & "&action=sendTTS"

astrPage = hs.GetURLIE(astrHTTP,True)

End sub
