'-----------------------------------------------------------------------
'-------------------------  DOMOTICS LIBRARY ---------------------------
'-- OBJECTIVES : Many functions to simplify your Homeseer scripting
'-- LICENSE    : FREE OF CHARGE FOR NON-COMMERCIAL USE
'-----------------------------------------------------------------------

'--------------------------------------------------------------------
'-- OBJECTIVE   : PROCEDURE >> Insert a Log
'-- PREREQUISITE: N/A
'-- PARAMS IN   : Name		(for example MANAGE.SHUTTERS)
'--				  Script		(for example manage.shutters.vbs)
'--				  Level		(for example SEVERE or CRITICAL)
'--				  Message	(for example "All shutters are off")
'--				  LogFile  	(for example path + logfile)
'-- PARAMS OUT  : N/A
'-- CREATED BY DOMOTICS
'-- 24/10/2005
'--------------------------------------------------------------------
Sub insertLog(aparamLevel, aparamModule, aparamScript, aparamDate, aparamDescription)
Dim aobjConn
Dim astrSQL

If (hs.GetVar(G_FOLDER_NAME & "_MODE") <> "" ) and (hs.GetVar(G_FOLDER_NAME & "_MODE") <> "ALONE" ) Then
	If (aParamLevel<>"") and (aparamModule<>"") and (aparamScript<>"") and (aparamDescription<>"") Then
		Set aobjConn = CreateObject("ADODB.Connection")
		aobjConn.Open(G_CONNECTION_STRING)
		astrSQL = "INSERT INTO LOGS (Level, Module, Script, Date, Description) VALUES ("
		astrSQL = astrSQL & "'" & aparamLevel & "', "
		astrSQL = astrSQL & "'" & aparamModule & "', "
		astrSQL = astrSQL & "'" & aparamScript & "', "
		astrSQL = astrSQL & "'" & formatDateVb2DateMysql(aparamDate) & "', "
		astrSQL = astrSQL & "'" & replace(trim(aparamDescription),"\","/") & "');"
		aobjConn.Execute astrSQL
		aobjConn.Close
		Set aobjConn = Nothing
	End if
End if
End sub

'--------------------------------------------------------------------
'-- OBJECTIVE   : PROCEDURE >> Save Device changes into the database
'-- PREREQUISITE: MYSQL + ODBC Driver for MYSQL + DATABASE + TABLE
'-- PARAMS IN   : Device 	(for example A1)
'-- PARAMS OUT  : N/A
'-- CREATED BY DOMOTICS
'-- 11/04/2003
'--------------------------------------------------------------------

Sub saveDeviceChange(astrDevice)
	SaveDeviceChangeWithAuthor astrDevice, G_DEFAULT_AUTHOR
End Sub

Sub saveDeviceChangeWithAuthor(astrDevice,astrAuthor)
Dim aobjConn				' Connection to the database
Dim astrConnectionString	' Connection String
Dim astrDatabase			' Path + File to find the database
Dim astrSQL					' Query to be executed
Dim aevtLast				' Last event trigered
Dim acodeLast				' Last code changed
Dim aDateTime				' Current Date and Time

'on error resume next
If (hs.GetVar(G_FOLDER_NAME & "_MODE") <> "" ) and (hs.GetVar(G_FOLDER_NAME & "_MODE") <> "ALONE" ) Then
	if (hs.DeviceExists(astrDevice)<>-1) then
	'-- STORE IT IN THE DATABASE
	'--
		Set aobjConn = CreateObject("ADODB.Connection")
		aobjConn.Open(G_CONNECTION_STRING)

	'------------------------------------------------------------------------------------
	'-- TABLE DES LOGS 
	'------------------------------------------------------------------------------------
	'ID_EVENT  bigint(20) unsigned          PRI     (NULL)               auto_increment
	'STRING    varchar(255)  
	'DEVICE    varchar(4)           YES             0                                  
	'STATUS    varchar(12)          YES             0                                  
	'VALUE     varchar(255)         YES             0                                  
	'DATE      datetime             YES             0000-00-00 00:00:00                
	'NOTES     varchar(255)   
	'------------------------------------------------------------------------------------

		aDateTime = Now()

		astrSQL = "INSERT INTO EVENTS (STRING, DEVICE, STATUS, VALUE, DATE, NOTES) VALUES ("
		astrSQL = astrSQL & "'" & hs.DeviceString(aStrDevice) & "',"
		astrSQL = astrSQL & "'" & astrDevice & "',"
		astrSQL = astrSQL & "'" & hs.DeviceStatus(astrDevice) & "',"
		astrSQL = astrSQL & "'" & hs.DeviceValue(astrDevice) & "',"
		astrSQL = astrSQL & "'" & Year(aDateTime) &"/"& Month(aDateTime) &"/"& Day(aDateTime) 
		astrSQL = astrSQL & " " & Hour(aDateTime) &":"& Minute(aDateTime) & "',"
		astrSQL = astrSQL & "'" & astrAuthor & "')"

		aobjConn.Execute astrSQL

		aobjConn.Close
		Set aobjConn = Nothing
	End	if
End if

End Sub

'--------------------------------------------------------------------
'-- OBJECTIVE   : FUNCTION >> Load a Device from Database
'-- PREREQUISITE: MYSQL + ODBC Driver for MYSQL + DATABASE + TABLE
'-- PARAMS IN   : Device 	(for example A1)
'-- PARAMS OUT  : N/A
'-- CREATED BY DOMOTICS
'-- 11/04/2003
'--------------------------------------------------------------------

Function loadDeviceFromDb(astrDevice)
Dim aobjConn 		' DATABASE ADO CONNECTION
Dim aobjRS			' RECORDSET TO PARSE THE RESULT
Dim astrQuery		' QUERY TO RETRIEVE VALUE
Dim aboolReturn

If (hs.GetVar(G_FOLDER_NAME & "_MODE") <> "" ) and (hs.GetVar(G_FOLDER_NAME & "_MODE") <> "ALONE" ) Then
	Set aobjConn = CreateObject("ADODB.Connection")
	aobjConn.Open(G_CONNECTION_STRING)

	astrQuery = "SELECT DEVICE, STATUS, VALUE, DATE, STRING, NOTES FROM EVENTS "
	astrQuery = astrQuery & "WHERE DEVICE='" & astrDevice & "' "
	astrQuery = astrQuery & "ORDER BY ID_EVENT DESC LIMIT 1" 
				
	Set aobjRS = aobjConn.Execute(astrQuery)
	If NOT(aobjRS.EOF) Then
		WriteLog G_DEFAULT_FOLDER_NAME, G_DEFAULT_SCRIPT, G_TIV_INF, "Loading from db : Device='" & aobjRS.Fields.Item(0) & _
			"', Status='" & aobjRS.Fields.Item(1) & "', Value='" & aobjRS.Fields.Item(2) & "', String='" & aobjRS.Fields.Item(4) & "'", G_DEFAULT_LOG_FILE
		SetDevice astrDevice, aobjRS.Fields.Item(4), aobjRS.Fields.Item(1), aobjRS.Fields.Item(2)
		hs.SetDeviceLastChange astrDevice, aobjRS.Fields.Item(3)
		aboolReturn = True	
	Else
		aboolReturn = False
	End if

	aobjConn.Close
	Set aobjRS = Nothing
	Set aobjConn = Nothing
Else
	aboolReturn = False
End if

LoadDeviceFromDb = aboolReturn

End Function
