'-----------------------------------------------------------------------
'-------------------------  DOMOTICS LIBRARY ---------------------------
'-- OBJECTIVES : Many functions to simplify your Homeseer scripting
'-- LICENSE    : FREE OF CHARGE FOR NON-COMMERCIAL USE
'-----------------------------------------------------------------------

'--------------------------------------------------------------------
'-- OBJECTIVE   : FUNCTION >> Clean a string. This function is used 
'--							 for html downloaded page.
'-- PREREQUISITE: N/A
'-- PARAMS IN   : Page	(for example meteo.htm from yahoo.fr)
'-- PARAMS OUT  : The same page with strange characters deleted
'-- CREATED BY DOMOTICS
'-- 24/04/2005
'--------------------------------------------------------------------

Function CleanString(astrPage)
Dim astrPageTmp

astrPageTmp = astrPage
astrPageTmp = Replace(astrPageTmp, chr(10), "")
astrPageTmp = Replace(astrPageTmp, chr(41), "")
astrPageTmp = Replace(astrPageTmp, chr(13), "")
astrPageTmp = Replace(astrPageTmp, chr(42), "")
astrPageTmp = Replace(astrPageTmp, chr(43), "")
astrPageTmp = Replace(astrPageTmp, chr(11), "")
astrPageTmp = Replace(astrPageTmp,  chr(9), "")
astrPageTmp = Replace(astrPageTmp, chr(29), "")
astrPageTmp = Replace(astrPageTmp, chr(30), "")	
CleanString = astrPageTmp
End Function

'--------------------------------------------------------------------
'-- OBJECTIVE   : FUNCTION >> Extract a string between 2 Strings
'-- PREREQUISITE: N/A
'-- PARAMS IN   : First String
'--				  Second String
'--				  Source to be used for extraction
'-- PARAMS OUT  : The extracted string
'-- CREATED BY DOMOTICS
'-- 15/05/2005
'--------------------------------------------------------------------

Function extractStringBetweenTwoTags(astrBegin, astrEnd, astrBuffer)
Dim aintBegin
Dim aintEnd

aintBegin = instr(astrBuffer,astrBegin)
If aintBegin > 0 Then
	aintBegin = aintBegin + len(astrBegin)
	aintEnd = instr(aintBegin,astrBuffer,astrEnd)
	ExtractStringBetweenTwoTags = mid(astrBuffer,aintBegin,aintEnd - aintBegin)	  
Else
	ExtractStringBetweenTwoTags = ""	  
End if
End Function


'--------------------------------------------------------------------
'-- OBJECTIVE   : FUNCTION >> Extract a string From another string.
'--					Extract n characters.
'-- PREREQUISITE: N/A
'-- PARAMS IN   : First String		(Begining)
'--				  How many characters to be extracted
'--				  Source to be used for extraction
'-- PARAMS OUT  : The extracted string
'-- CREATED BY DOMOTICS
'-- 15/05/2005
'--------------------------------------------------------------------

Function extractStringFromOneTag(astrBegin, aintNbCar, astrBuffer)
Dim aintBegin
Dim aintEnd

aintBegin = instr(astrBuffer,astrBegin)
If aintBegin > 0 Then
	aintBegin = aintBegin + len(astrBegin)
	ExtractStringFromOneTag = mid(astrBuffer,aintBegin,aintNbCar)
Else
	ExtractStringFromOneTag = ""	  
End if	
End Function

'--------------------------------------------------------------------
'-- OBJECTIVE   : FUNCTION >> Convert Date to insert in MySQL
'-- PREREQUISITE: N/A
'-- PARAMS IN   : a str as date  
'-- PARAMS OUT  : a str as converted date
'-- CREATED BY DOMOTICS
'-- 10/10/2005
'--------------------------------------------------------------------
Function formatDateVb2DateMysql(aparamStrDate) 
Dim astrBuffer
Dim atabDate
Dim atabHour
Dim atabDateHour

' 25/09/2005 22:15:00 to 0000-00-00 00:00:00
atabDateHour = Split(aparamStrDate, " ")
atabDate = Split(atabDateHour(0), "/")
atabHour = Split(atabDateHour(1), ":")

astrBuffer = atabDate(2) & "-" & atabDate(1) & "-" & atabDate(0) 
astrBuffer = astrBuffer & " " & atabHour(0) & ":" & atabHour(1) & ":" & atabHour(2)
	
formatDateVb2DateMysql = astrBuffer
End Function


'--------------------------------------------------------------------
'-- OBJECTIVE   : FUNCTION >> Convert Date to string like 20051012
'-- PREREQUISITE: N/A
'-- PARAMS IN   : a str as date  
'-- PARAMS OUT  : a str as converted date
'-- CREATED BY DOMOTICS
'-- 10/10/2005
'--------------------------------------------------------------------

Function formatDate4FileSys(aparamDATE)
Dim astrBuffer

astrBuffer = year(aparamDATE)

If month(aparamDATE) < 10 Then
	astrBuffer = astrBuffer & "0" & month(aparamDATE)
Else
	astrBuffer = astrBuffer & month(aparamDATE)
End if

If day(aparamDATE) < 10 Then
	astrBuffer = astrBuffer & "0" & day(aparamDATE)
Else
	astrBuffer = astrBuffer & day(aparamDATE)
End if

formatDate4FileSys = astrBuffer
End Function

'--------------------------------------------------------------------
'-- OBJECTIVE   : Map value according KEYWORD
'-- PREREQUISITE: N/A
'-- PARAMS IN   : String
'-- PARAMS OUT  : String 
'-- CREATED BY DOMOTICS
'-- 14/11/2005
'--------------------------------------------------------------------
Function mapKeyWord(aparamStr)
If UCase(aparamStr) = "SUNRISE" Then
	mapKeyWord = hs.sunrise								 
ElseIf UCase(aparamStr) = "SUNSET" Then
	 mapKeyWord = hs.sunset
Else mapKeyWord = aparamStr
End If 
End Function

'--------------------------------------------------------------------
'-- OBJECTIVE   : Check if it is the period to launch the device
'-- PREREQUISITE: N/A
'-- PARAMS IN   : Period string object
'--				  Delta if necessary (ex: for radiators)
'-- PARAMS OUT  : True or False
'-- CREATED BY DOMOTICS
'-- 14/11/2005
'--------------------------------------------------------------------
Function isPeriod(aparamPeriods,aparamDelta)
Dim adateBegin
Dim adateEnd
Dim atabPeriods
Dim i
Dim atabParams
Dim aboolPeriod
Dim adateDelta

If aparamDelta = "" Then
	adateDelta = Cdate("00:00")	
Else
	adateDelta = Cdate(aparamDelta)
End if

If (aparamPeriods <> "") Then
	atabPeriods = Split(aparamPeriods,G_SEP)
	i=0	
	aboolPeriod = False
	While (i <= Ubound(atabPeriods)) and Not(aboolPeriod)
	
		atabParams = Split(atabPeriods(i),G_COMMA)

		If Ubound(atabParams) = 0 Then					'i.e. 1
			If atabParams(0) = "ALWAYS" Then
				aboolPeriod = True
			End if
			
		ElseIf Ubound(atabParams) = 1 Then 				'i.e. 2
			If atabParams(0) = "MANUAL" Then
				If (atabParams(1) <> "") and (hs.DeviceStatus(atabParams(1)) = G_STATUS_ON) Then
					aboolPeriod = True
				End if
				
			ElseIf atabParams(0) = "BEFORE" Then
				If (atabParams(1) <> "") Then
					If (DateDiff("N",now(),cdate(date() & " " & cdate(mapKeyWord(atabParams(1))))) >= 0) Then
						aboolPeriod = True
					End If				
				End If
			
			ElseIf atabParams(0) = "AFTER" Then
				If (atabParams(1) <> "") Then
					If (DateDiff("N",cdate(date() & " " & cdate(cdate(mapKeyWord(atabParams(1))) - adateDelta)), Now()) >= 0) Then
						aboolPeriod = True
					End If
				End If
			End If
			
		ElseIf Ubound(atabParams) = 2 Then				'i.e. 3
			If atabParams(0) = "BETWEEN" Then
				If (atabParams(1) <> "") and (atabParams(2) <> "") Then
					If (DateDiff("N",now(),cdate(date() & " " & cdate(mapKeyWord(atabParams(2))))) >= 0)  and _
					   (DateDiff("N",cdate(date() & " " & cdate(cdate(mapKeyWord(atabParams(1))) - adateDelta)), Now()) >= 0) Then
						aboolPeriod = True
					End If					
				End if
			ElseIf atabParams(0) = "BEFORE" Then
				If (atabParams(1) <> "") and (atabParams(2) <> "") Then
					If (DateDiff("N",now(),cdate(date() & " " & cdate(cdate(mapKeyWord(atabParams(1))) - cdate(atabParams(2))))) >= 0) Then
						aboolPeriod = True
					End If					
				End if
				
			ElseIf atabParams(0) = "AFTER" Then
				If (atabParams(1) <> "") and (atabParams(2) <> "") Then
					If (DateDiff("N",cdate(date() & " " & cdate(cdate(mapKeyWord(atabParams(1))) - adateDelta - cdate(atabParams(2)))), Now()) >= 0) Then
						aboolPeriod = True
					End If					
				End if
			End If
			
		End if		
		i=i+1
	Wend
	isPeriod = aboolPeriod
Else
	isPeriod = False
End if
End Function

'--------------------------------------------------------------------
'-- OBJECTIVE   : FUNCTION >> Delete double space character
'-- PREREQUISITE: N/A
'-- PARAMS IN   : String
'-- PARAMS OUT  : String without double space character
'-- CREATED BY DOMOTICS
'-- 02/12/2005
'--------------------------------------------------------------------
Function deleteSpaceChar(aparamStr)
Dim astrTmp

astrTmp = aparamStr
While (Instr(astrTmp,"  ") > 0) 
	astrTmp = replace(astrTmp,"  "," ")
Wend
deleteSpaceChar = astrTmp
End Function

'--------------------------------------------------------------------
'-- OBJECTIVE   : Check darkness
'-- PREREQUISITE: N/A
'-- PARAMS IN   : dark devices separated by |
'-- PARAMS OUT  : True or False
'-- CREATED BY DOMOTICS
'-- 18/05/2006
'--------------------------------------------------------------------
Function isDark(aparamDarkDevices) 
Dim atabDarkDevices
Dim i
Dim astrStatus

isDark = False
If (aparamDarkDevices <> "") Then
	atabDarkDevices = Split(aparamDarkDevices,G_SEP)
	i=0	
	If (atabDarkDevices(i) = "DARK") Then
		i = i + 1
		While (i <= Ubound(atabDarkDevices))
			astrStatus = hs.DeviceStatus(atabDarkDevices(i))
			If (astrStatus = G_STATUS_ON) and (DateDiff("N",now(),cdate(date() & " " & cdate(mapKeyWord(atabParams(1))))) >= 0) Then
				isDark = True
			Else 
				isDark = False	
			End if
			i=i+1
		Wend
	End if
End if
End Function

'--------------------------------------------------------------------
'-- OBJECTIVE   : Check if the given Policy is applicable
'-- PREREQUISITE: N/A
'-- PARAMS IN   : POLICY as a string object
'-- PARAMS OUT  : True or False + G_STR_BUFFER
'-- CREATED BY DOMOTICS                                                        
'-- 07/07/2006
'--------------------------------------------------------------------
Sub	doExpression(byval aparamPolicy, byref aparamReturn, byref aparamTypeValue, byref aparamValue)
Dim astrPolicy
Dim atabExpressions
Dim atabTerms
Dim atabParams
Dim i
Dim aboolFinish
Dim aintAND
Dim aintOR
Dim aintCpt
Dim astrBuffer
Dim astrTerm
Dim astrOperator
Dim avarResult
Dim avarTmp
Dim aG_DEFAULT_SCRIPT

aG_DEFAULT_SCRIPT = G_DEFAULT_SCRIPT & ".doExpression"
astrPolicy = aparamPolicy
If (astrPolicy <> "") Then
'-- Cleaning Step -------------------------------------------------------------
	astrPolicy = replace(astrPolicy, "[",  "")
	astrPolicy = replace(astrPolicy, "]|", "|")
	astrPolicy = replace(astrPolicy, "]&", "&")	
	
	If right(astrPolicy,1) = "]" Then
		astrPolicy=Left(astrPolicy,len(astrPolicy)-1)
	End if
	WriteLog G_DEFAULT_FOLDER_NAME, aG_DEFAULT_SCRIPT, G_TIV_INF, "Policy has been improved : " & astrPolicy, G_DEFAULT_LOG_FILE	

	aintAND 	= 0
	aintOR  	= 0
	astrBuffer 	= astrPolicy
	astrOperator= ""
	avarResult	= True
	While (astrBuffer <> "")
		aintAND	=	instr(astrBuffer, "&")
		aintOR	=	instr(astrBuffer, "|")
		If (aintAND > 0) or (aintOR > 0) Then
			If aintOR = 0 Then
				aintCpt 		= aintAND
				astrOperator 	= "&" 
			Elseif aintAND = 0 Then
				aintCpt 		= aintOR
				astrOperator 	= "|" 
			Elseif aintAND > aintOR Then
				aintCpt 		= aintOR
				astrOperator 	= "|" 
			Else
				aintCpt 		= aintAND
				astrOperator 	= "&" 
			End if
			astrTerm   	= Left(astrBuffer, aintCpt-1)
			astrBuffer 	= Right(astrBuffer,Len(astrBuffer)-aintCpt)
		Else
			astrTerm 	= astrBuffer
			astrBuffer 	= ""	
		End if	
		
'		avarTmp = doTerm(astrTerm)
    doTerm astrTerm, avarTmp, aparamTypeValue, aparamValue
		avarResult = avarTmp
		
		If astrOperator = "&" Then
			If (avarTmp = False) Then
				astrBuffer 	= ""
			End if
		Else ' astrOperator = "|"
			If avarTmp <> False Then
				astrBuffer 	= ""
			End if
		End if
		
		If astrBuffer <> "" Then
		  WriteLog G_DEFAULT_FOLDER_NAME, aG_DEFAULT_SCRIPT, G_TIV_INF, "Continuing with " & astrBuffer, G_DEFAULT_LOG_FILE
    End if	

	Wend
Else
  avarResult = False  
End If
aparamReturn = avarResult
End Sub

'--------------------------------------------------------------------
'-- OBJECTIVE   : 
'-- PREREQUISITE: 
'-- PARAMS IN   : 
'-- PARAMS OUT  : 
'-- CREATED BY DOMOTICS                                                        
'-- 01/07/2006
'--------------------------------------------------------------------
Sub doTerm(byval aparamTerm, byref aparamReturn, byref aparamTypeValue, byref aparamValue)
Dim atabOperands	
Dim avarValue
Dim aG_DEFAULT_SCRIPT

aG_DEFAULT_SCRIPT = G_DEFAULT_SCRIPT & ".doTerm"
aparamReturn = True
atabOperands = Split(aparamTerm,"]")
If Ubound(atabOperands) >= 0 Then
  doOperand atabOperands(0), aparamReturn, aparamTypeValue, aparamValue
  					
	If Ubound(atabOperands) = 0 Then
      
		
	ElseIf Ubound(atabOperands) = 1 Then
    If aparamReturn Then	
        WriteLog G_DEFAULT_FOLDER_NAME, aG_DEFAULT_SCRIPT, G_TIV_INF, aparamTerm & " returns " & aparamReturn & " lauching " & atabOperands(1),G_DEFAULT_LOG_FILE
        doOperand atabOperands(1), aparamReturn, aparamTypeValue, aparamValue
    End if
    	
	ElseIf Ubound(atabOperands) = 2 Then 				
		If aparamReturn Then
		  WriteLog G_DEFAULT_FOLDER_NAME, aG_DEFAULT_SCRIPT, G_TIV_INF, aparamTerm & " returns " & aparamReturn & " lauching " & atabOperands(1),G_DEFAULT_LOG_FILE
			doOperand atabOperands(1), aparamReturn, aparamTypeValue, aparamValue
		Else
		  WriteLog G_DEFAULT_FOLDER_NAME, aG_DEFAULT_SCRIPT, G_TIV_INF, aparamTerm & " returns " & aparamReturn & " lauching " & atabOperands(2),G_DEFAULT_LOG_FILE
			doOperand atabOperands(2), aparamReturn, aparamTypeValue, aparamValue
		End if
		
	Else
		aparamReturn = False
	End if
Else
	WriteLog G_DEFAULT_FOLDER_NAME, aG_DEFAULT_SCRIPT, G_TIV_INF, "Unknown use case ([] problem) : " & aparamTerm , G_DEFAULT_LOG_FILE	
End if

WriteLog G_DEFAULT_FOLDER_NAME, aG_DEFAULT_SCRIPT, G_TIV_INF, aparamTerm & " returns " & aparamReturn &"/" & aparamTypeValue & "/" & aparamValue, G_DEFAULT_LOG_FILE
	
End Sub

'--------------------------------------------------------------------
'-- OBJECTIVE   : 
'-- PREREQUISITE: 
'-- PARAMS IN   : 
'-- PARAMS OUT  : 
'-- CREATED BY DOMOTICS
'-- 12/06/2006
'--------------------------------------------------------------------
Sub doOperand(byval aparamOperand, byref aparamReturn, byref aparamTypeValue, byref aparamValue)
Dim astrOperator
Dim aboolReturn1
Dim aboolReturn2
Dim avarValue1
Dim avarValue2
Dim avarTypeValue1
Dim avarTypeValue2
Dim atabOperands
Dim astrExtracted
Dim atabSplit
Dim astrStatus
Dim aG_DEFAULT_SCRIPT
Dim adateDelta

aG_DEFAULT_SCRIPT = G_DEFAULT_SCRIPT & ".doOperand"

astrOperator 	= searchOperator(aparamOperand)

'-- OPERAND is a CONDITION -----------------------------------------------------
If (astrOperator = ">")  or (astrOperator = ">=") or (astrOperator = "<") or _
   (astrOperator = "<=") or (astrOperator = "=")  or (astrOperator = "<>") Then
	atabOperands 	= Split(aparamOperand,astrOperator) 
	If Ubound(atabOperands) = 1 Then
	  doArgument atabOperands(0), aboolReturn1, avarTypeValue1, avarValue1
    doArgument atabOperands(1), aboolReturn2, avarTypeValue2, avarValue2    	  
		If (aboolReturn1 and aboolReturn2) Then
			If ((astrOperator = ">" ) and (avarValue1 >  avarValue2)) or _ 
			   ((astrOperator = ">=") and (avarValue1 >= avarValue2)) or _
			   ((astrOperator = "<" ) and (avarValue1 <  avarValue2)) or _
			   ((astrOperator = "<=") and (avarValue1 <= avarValue2)) or _
			   ((astrOperator = "=" ) and (avarValue1 =  avarValue2)) or _
			   ((astrOperator = "<>") and (avarValue1 <> avarValue2))    	Then
				aparamReturn = True
			Else
				aparamReturn	= False
			End if
		Else
			aparamReturn		= False
		End if 
	Else
		aparamReturn = False
	End if
	
'-- OPERAND is a EXTRACTFROMTO -------------------------------------------------	
ElseIf astrOperator = "EXTRACTFROMTO" Then
	atabOperands 	= Split(aparamOperand,G_COMMA)
	If Ubound(atabOperands) = 2 Then
		astrExtracted = trim(ExtractStringBetweenTwoTags(atabOperands(1), atabOperands(2), aparamValue))
		If astrExtracted <> "" Then
			aparamReturn = True
			aparamTypeValue = G_TYPE_STRING
			aparamValue = astrExtracted
		Else
			aparamReturn = True
			aparamTypeValue = G_TYPE_STRING
			aparamValue = G_DEFAULT_VALUE
		End if
	Else
		aparamReturn 	= False
	End if
	
'-- OPERAND is a SPLIT ---------------------------------------------------------	
ElseIf astrOperator = "SPLIT" Then
	atabOperands 	= Split(aparamOperand, G_COMMA)
	If Ubound(atabOperands) = 2 Then
		atabSplit   = Split(aparamValue, atabOperands(1))
		If Ubound(atabSplit) >= (atabOperands(2)-1) Then
			aparamReturn = True
			aparamTypeValue = G_TYPE_STRING
			aparamValue = atabSplit(atabOperands(2)-1)
		Else
			aparamReturn = True
			aparamTypeValue = G_TYPE_STRING
			aparamValue = G_DEFAULT_VALUE	
		End if
	Else
		aparamReturn = False
	End if

'-- OPERAND is a BETWEEN --------------------------------------------------------	
'-- BETWEEN;SUNSET;SUNRISE;1:00;DIM,10
ElseIf astrOperator = "BETWEEN" Then
	atabOperands 	= Split(aparamOperand, G_COMMA)
	aparamReturn = False
	If Ubound(atabOperands) = 4 Then
	  adateDelta = Cdate(atabOperands(3))
	  If IsDate(adateDelta) = False Then
	     adateDelta = Cdate("00:00")
	  End if
    If (atabOperands(1) <> "") and (atabOperands(2) <> "") Then
      If (DateDiff("N",now(),cdate(date() & " " & cdate(mapKeyWord(atabOperands(2))))) >= 0) and _
				 (DateDiff("N",cdate(date() & " " & cdate(cdate(mapKeyWord(atabOperands(1))) - adateDelta)), _
          Now()) >= 0) Then
              doArgument atabOperands(4), aparamReturn, aparamTypeValue, aparamValue 
			End If					
		End if	
	End if
	  
'-- OPERAND is a BEFORE --------------------------------------------------------	
'-- BEFORE;SUNSET;1:00;DIM,10
ElseIf astrOperator = "BEFORE" Then
	atabOperands 	= Split(aparamOperand, G_COMMA)
	aparamReturn = False
	If Ubound(atabOperands) = 3 Then
	  adateDelta = Cdate(atabOperands(2))
	  If IsDate(adateDelta) = False Then
	     adateDelta = Cdate("00:00")
	  End if
    If (atabOperands(1) <> "") Then
	 	   If (DateDiff("N",now(),cdate(date() & " " & cdate(cdate(mapKeyWord(atabOperands(1))) - adateDelta))) >= 0) Then
              doArgument atabOperands(3), aparamReturn, aparamTypeValue, aparamValue 
			 End If					
		End if	
	End if 

'-- OPERAND is a AFTER --------------------------------------------------------	
'-- AFTER;SUNSET;1:00;DIM,10
ElseIf astrOperator = "AFTER" Then
	atabOperands 	= Split(aparamOperand, G_COMMA)
	aparamReturn = False
	If Ubound(atabOperands) = 3 Then
	  adateDelta = Cdate(atabOperands(2))
	  If IsDate(adateDelta) = False Then
	     adateDelta = Cdate("00:00")
	  End if
    If (atabOperands(1) <> "") Then
      If (DateDiff("N",cdate(date() & " " & cdate(cdate(mapKeyWord(atabOperands(1))) - adateDelta )), Now()) >= 0) Then
              doArgument atabOperands(3), aparamReturn, aparamTypeValue, aparamValue 
			End If					
		End if	
	End if 
    
'-- ELSE ------------------------------------------------------------------------   
Else
  doArgument aparamOperand, aparamReturn, aparamTypeValue, aparamValue
End if
End Sub

'--------------------------------------------------------------------
'-- OBJECTIVE   : 
'-- PREREQUISITE: 
'-- PARAMS IN   : 
'-- PARAMS OUT  : 
'-- CREATED BY DOMOTICS
'-- 12/06/2006
'--------------------------------------------------------------------
Sub doArgument(byval aparamArgument, byref aparamReturn, byref aparamTypeValue, byref aparamValue)
Dim astrStatus
Dim astrValue
Dim astrString
Dim aG_DEFAULT_SCRIPT
Dim atabParams

aG_DEFAULT_SCRIPT = G_DEFAULT_SCRIPT & ".doArgument"
If isNumeric(aparamArgument) Then
	aparamValue = CDbl(aparamArgument)
	aparamTypeValue = G_TYPE_DBL
	aparamReturn = True
	
Elseif (hs.DeviceExists(aparamArgument) > -1) Then
	astrStatus = hs.DeviceStatus(aparamArgument)	
	astrValue  = hs.DeviceValue(aparamArgument)
	astrString = hs.DeviceString(aparamArgument)
	
  If (astrStatus = G_STATUS_ON) or (astrStatus = G_STATUS_OFF) Then
	   aparamValue = astrStatus
	   aparamTypeValue = astrStatus
	   aparamReturn = True
	   
  ElseIf isNumeric(astrValue) Then
	   aparamValue = CDbl(astrValue)
	   aparamTypeValue = G_TYPE_DBL
	   aparamReturn = True
 	   
	Else
	   If IsNumeric(astrString) Then
  	   aparamValue = CDbl(astrString)
	     aparamTypeValue = G_TYPE_DBL
	     aparamReturn = True
     Else
  	   aparamValue = astrString
	     aparamTypeValue = G_TYPE_STRING
	     aparamReturn = True
     End if
	End if

ElseIf (aparamArgument = "ON") Then
	   aparamValue = G_STATUS_ON
	   aparamTypeValue = G_STATUS_ON
	   aparamReturn = True

ElseIf (aparamArgument = "OFF") Then
	   aparamValue = G_STATUS_OFF
	   aparamTypeValue = G_STATUS_OFF
	   aparamReturn = True

ElseIf (Left(aparamArgument,3) = "DIM") Then
     atabParams = Split(aparamArgument,G_SIMPLE_COMMA)
     aparamReturn = False
     If UBound(atabParams) = 1 Then
        If isNumeric(atabParams(1)) Then
	         aparamValue = CDbl(atabParams(1))
	         aparamReturn = True
	         If (Left(aparamArgument,3) = "DIM") Then
	           aparamTypeValue = G_STATUS_DIM
	         ElseIf (Left(aparamArgument,5) = G_STR_DIM_FROM_BOTTOM) Then
	           aparamTypeValue = G_STATUS_DIM_FROM_BOTTOM
	         ElseIf (Left(aparamArgument,5) = G_STR_DIM_FROM_TOP) Then
	           aparamTypeValue = G_STATUS_DIM_FROM_TOP
	         End if
	      End if
     End if

ElseIf (Left(aparamArgument,6) = "BRIGHT")  Then
     atabParams = Split(aparamArgument,G_SIMPLE_COMMA)
     aparamReturn = False
     If UBound(atabParams) = 1 Then
        If isNumeric(atabParams(1)) Then
	         aparamValue = CDbl(atabParams(1))
	         aparamReturn = True
	         If (Left(aparamArgument,6) = "BRIGHT") Then
	           aparamTypeValue = G_STATUS_BRIGHT
	         ElseIf (Left(aparamArgument,8) = G_STR_BRIGHT_FROM_BOTTOM) Then
	           aparamTypeValue = G_STATUS_BRIGHT_FROM_BOTTOM
	         ElseIf (Left(aparamArgument,8) = G_STR_BRIGHT_FROM_TOP) Then
	           aparamTypeValue = G_STATUS_BRIGHT_FROM_TOP
	         End if
	      End if
     End if
     
ElseIf (Left(aparamArgument,8) = "EXTENDED")  Then
     atabParams = Split(aparamArgument, G_SIMPLE_COMMA)
     aparamReturn = False
     If UBound(atabParams) = 1 Then
        If isNumeric(atabParams(1)) Then
	         aparamValue = CDbl(atabParams(1))
	         aparamReturn = True
	         aparamTypeValue = G_STATUS_EXTENDED
	      End if
     End if     
          		
Else
	aparamReturn = False
End if

WriteLog G_DEFAULT_FOLDER_NAME, aG_DEFAULT_SCRIPT, G_TIV_INF, "Requesting with " & aparamArgument & " and answering " & Cstr(aparamReturn) & "/" & aparamTypeValue & "/" & aparamValue, G_DEFAULT_LOG_FILE
End Sub

'--------------------------------------------------------------------
'-- OBJECTIVE   : 
'-- PREREQUISITE: 
'-- PARAMS IN   : 
'-- PARAMS OUT  : 
'-- CREATED BY DOMOTICS
'-- 12/06/2006
'--------------------------------------------------------------------
Function searchOperator(aparamOperand)
Dim avarRet

If (Instr(UCase(aparamOperand),"EXTRACTFROMTO") > 0 ) Then
	searchOperator = "EXTRACTFROMTO"
	
ElseIf (Instr(UCase(aparamOperand),"SPLIT") > 0 ) Then
	searchOperator = "SPLIT"

ElseIf (Instr(UCase(aparamOperand),"BEFORE") > 0 ) Then
	searchOperator = "BEFORE"
  
ElseIf (Instr(UCase(aparamOperand),"AFTER") > 0 ) Then
	searchOperator = "AFTER"
  
ElseIf (Instr(UCase(aparamOperand),"BETWEEN") > 0 ) Then
	searchOperator = "BETWEEN"    	

ElseIf 	(Instr(aparamOperand,"<=") > 0) or (Instr(aparamOperand,"=<") > 0) Then 	
	searchOperator = "<="
	
ElseIf 	(Instr(aparamOperand,">=") > 0) or (Instr(aparamOperand,"=>") > 0) Then 	
	searchOperator = ">="
	
ElseIf 	Instr(aparamOperand,"<>") > 0 Then 	
	searchOperator = "<>"

ElseIf 		Instr(aparamOperand,">") > 0 Then 	
	searchOperator = ">"
	
ElseIf 	Instr(aparamOperand,"<") > 0 Then 	
	searchOperator = "<"
  	
ElseIf 	(Instr(aparamOperand,"=") > 0) or (Instr(aparamOperand,"==") > 0) Then 	
	searchOperator = "="
	
Else 										
	searchOperator = ""
End if
End Function


