'-----------------------------------------------------------------------
'-------------------------  DOMOTICS LIBRARY ---------------------------
'-- OBJECTIVES : Many functions to simplify your Homeseer scripting
'-- LICENSE    : FREE OF CHARGE FOR NON-COMMERCIAL USE
'-----------------------------------------------------------------------

'--------------------------------------------------------------------
'-- OBJECTIVE   : FUNCTION >> GENERATE BATCH FILE
'-- PREREQUISITE: N/A
'-- PARAMS IN   : String (Cdes for the bat file)
'--				  String (Expected filename)
'-- PARAMS OUT  : String ("" or the complete file wit path)
'-- CREATED BY DOMOTICS
'-- 26/02/2006
'--------------------------------------------------------------------
Function generateBatFile(aparamCDE, aparamFile)
Dim astrLocalFile

astrLocalFile = G_TMP_FOLDER
If isFolderExist(astrLocalFile) Then
	astrLocalFile 	= astrLocalFile & aparamFile & ".bat"
	aparamCDE		= replace(aparamCDE, "Program Files", "Progra~1")
	SaveFilebyType astrLocalFile, aparamCDE, G_FILETYPE_SYSTEM
	If isFileExist(astrLocalFile) Then
			generateBatFile = """" & astrLocalFile & """"
	Else	generateBatFile = ""
	End if
Else generateBatFile = ""
End if
End Function

'--------------------------------------------------------------------
'-- OBJECTIVE   : FUNCTION >> IS ALIVE
'-- PREREQUISITE: SYSINTERNAL FILES
'-- PARAMS IN   : String (Process to be checked)
'-- PARAMS OUT  : Int (-1 or the used memory)
'-- CREATED BY DOMOTICS
'-- 26/02/2006
'--------------------------------------------------------------------
Function isAlive(aparamPROCESS)
Dim astrOUTPUT
Dim astrRUN
Dim astrBuffer
Dim atabBAT
Dim aintDATA
Dim j
Dim atabDATA
Dim astrString

If G_PS_PROG = "" Then	
	isAlive = -1
Else
	astrOUTPUT 	= G_TMP_FOLDER & aparamPROCESS & ".txt"
	astrRUN 	= generateBatFile("""" & G_PS_PROG & """ -e -m """ & aparamPROCESS & """ > """ & astrOUTPUT & """", aparamPROCESS & "-alive") 
	If astrRUN = "" Then
'		WriteLog G_FOLDER_NAME, G_SCRIPT_EVT, G_TIV_CRI, astrRUN & " is not found !!!", G_LOG_FILE
		isAlive = -1
	Else	
		If executeShellAndWait(astrRUN) Then
		 	If isFileExist(astrOUTPUT) Then
				astrBuffer = LoadFile(astrOUTPUT, False)
				If InStr(astrBuffer, "was not found") <= 0 Then
					atabBAT		= Split(deleteSpaceChar(astrBuffer),aparamPROCESS)
					aintDATA	= 0
					j = 1
					While j <= Ubound(atabBAT)
						atabDATA = Split(atabBAT(j)," ")
						If Ubound(atabDATA) >= 3 Then
							aintDATA = aintDATA + atabDATA(3)
						Else
							astrString = 0
						End if
						j=j+1
					Wend
					If aintDATA <> 0 Then
						isAlive = Cstr(aintDATA)
					Else
						isAlive = -1
'						WriteLog G_FOLDER_NAME, G_SCRIPT_EVT, G_TIV_CRI, "Error decoding ps results", G_LOG_FILE
					End if
				Else
					isAlive = 0
				End if
			Else
'				WriteLog G_FOLDER_NAME, G_SCRIPT_EVT, G_TIV_CRI, astrOUTPUT & " is not found !!!", G_LOG_FILE
			End if
		Else
'			WriteLog G_FOLDER_NAME, G_SCRIPT_EVT, G_TIV_CRI, astrRUN & " has failed !!!", 	G_LOG_FILE
		End if	
	End if
End if
End Function

'--------------------------------------------------------------------
'-- OBJECTIVE   : FUNCTION >> KILL PROCESS
'-- PREREQUISITE: SYSINTERNAL FILES
'-- PARAMS IN   : String (Process to be killed)
'-- PARAMS OUT  : String (True or False)
'-- CREATED BY DOMOTICS
'-- 26/02/2006
'--------------------------------------------------------------------
Function killProcess(aparamPROCESS)
Dim astrRUN

If G_KILL_PROG = "" Then	
	killProcess = False
Else
	astrRUN 	= generateBatFile("""" & G_KILL_PROG & """ """ & aparamPROCESS & """", aparamPROCESS & "-kill") 
	If astrRUN = "" Then
'		WriteLog G_FOLDER_NAME, G_SCRIPT_EVT, G_TIV_CRI, astrRUN & " is not found !!!", G_LOG_FILE
		killProcess = False
	Else	
		If executeShellAndWait(astrRUN) Then
'			WriteLog G_FOLDER_NAME, G_SCRIPT_EVT, G_TIV_INF, aparamPROCESS & " killed", G_LOG_FILE
			killProcess = True
		Else
'			WriteLog G_FOLDER_NAME, G_SCRIPT_EVT, G_TIV_CRI, astrRUN & " has failed !!!", 	G_LOG_FILE
			killProcess = True
		End if	
	End if
End if		 		 	
End Function

'--------------------------------------------------------------------
'-- OBJECTIVE   : FUNCTION >> Execute a shell (external command line)
'-- PREREQUISITE: N/A
'-- PARAMS IN   : Command		(for example c:/toto.bat)
'-- PARAMS OUT  : TRUE if the script was executed
'--				  FALSE if the execution isn't possible
'-- CREATED BY DOMOTICS
'-- 15/05/2005
'--------------------------------------------------------------------
Function executeAdvancedShell(astrCDE,aparamWindow,aparamWait)
Dim astrStoppedShell
Dim WshShell
Dim astrWindow
Dim aboolWait

If (G_BLOCK_ALL_EXT_SCRIPTS <> "") and (hs.DeviceExists(G_BLOCK_ALL_EXT_SCRIPTS <> -1)) Then
	astrStoppedShell = hs.DeviceStatus(G_BLOCK_ALL_EXT_SCRIPTS)
	if astrStoppedShell = G_STATUS_OFF then
		Set WshShell = CreateObject("Wscript.Shell")
		If (aparamWindow = "") or (aparamWindow = "0") Then 
			astrWindow = 0
		Else 
			astrWindow = aparamWindow
		End if
		If (aparamWait = "") or (aparamWait = True) Then 
			aboolWait = True
		Else 
			aboolWait = False
		End if
		WshShell.Run astrCDE, astrWindow, aboolWait   
		Set WshShell = Nothing
		executeAdvancedShell=True
	Else
		executeAdvancedShell=False
	End if
Else
	executeAdvancedShell=False
End if
End Function

Function executeShellWithoutWait(astrCDE)
executeShellWithoutWait = executeAdvancedShell(astrCDE, 0, False)
End Function

Function executeShellAndWait(astrCDE)
executeShellAndWait = executeAdvancedShell(astrCDE,0,True)
End Function

Function executeShell(astrCDE)
executeShell  = executeAdvancedShell(astrCDE,0,True)
End Function
